

Imports System.Runtime.InteropServices
Imports LC.Multimedia

Public MustInherit Class MidiDevice
	Inherits Device

    <DllImport("winmm.dll")> _
    Private Shared Function midiConnect(ByVal handleA As Integer, ByVal handleB As Integer, ByVal reserved As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiDisconnect(ByVal handleA As Integer, ByVal handleB As Integer, ByVal reserved As Integer) As Integer
    End Function


    Protected Shared ReadOnly SizeOfMidiHeader As Integer

    Shared Sub New()
        SizeOfMidiHeader = Marshal.SizeOf(GetType(MidiHeader))
    End Sub

    Public Sub New(ByVal deviceID As Integer)
        MyBase.New(deviceID)
    End Sub

    ' ----------------------------------------------- connects a MIDI InputDevice to a MIDI thru or OutputDevice, 
    '                                                 or connects a MIDI thru device to a MIDI OutputDevice
    '
    Public Shared Sub Connect(ByVal handleA As Integer, ByVal handleB As Integer)
        Dim result As Integer = midiConnect(handleA, handleB, 0)
        If result <> MidiDeviceException.MMSYSERR_NOERROR Then
            Throw New MidiDeviceException(result)
        End If
    End Sub


    ' ----------------------------------------------- disconnects a MIDI InputDevice from a MIDI thru or OutputDevice,
    '                                                 or disconnects a MIDI thru device from a MIDI OutputDevice
    '
    Public Shared Sub Disconnect(ByVal handleA As Integer, ByVal handleB As Integer)
        Dim result As Integer = midiDisconnect(handleA, handleB, 0)
        If result <> MidiDeviceException.MMSYSERR_NOERROR Then
            Throw New MidiDeviceException(result)
        End If
    End Sub

End Class
