

Imports System.Windows.Forms

Namespace UI

    Partial Public Class OutputDeviceDialog
        Inherits Form

        Private m_outputDeviceID As Integer = 0

        Public Sub New()
            InitializeComponent()
            If OutputDevice.DeviceCount > 0 Then
                For i As Integer = 0 To OutputDevice.DeviceCount - 1
                    Dim cap As MidiOutCaps = OutputDevice.GetDeviceCapabilities(i)
                    outputComboBox.Items.Add(cap.name)
                Next
                outputComboBox.SelectedIndex = m_outputDeviceID
            End If
        End Sub

        Protected Overloads Overrides Sub OnShown(ByVal e As EventArgs)
            If OutputDevice.DeviceCount > 0 Then
                outputComboBox.SelectedIndex = m_outputDeviceID
            End If
            MyBase.OnShown(e)
        End Sub

        Private Sub OkButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OkButton.Click
            If OutputDevice.DeviceCount > 0 Then
                m_outputDeviceID = outputComboBox.SelectedIndex
            End If
            DialogResult = DialogResult.OK
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
            DialogResult = DialogResult.Cancel
        End Sub

        Public Property OutputDeviceID() As Integer
            Get
                Return m_outputDeviceID
            End Get
            Set(ByVal value As Integer)
                m_outputDeviceID = value
            End Set
        End Property

    End Class

End Namespace
