

Public Class SampleRate

    Public Const SampleRateDefaultValue As Integer = 44100
    Private m_samplesPerSecond As Integer = SampleRateDefaultValue

    Public Event SampleRateChanged As EventHandler
    Protected Overridable Sub OnSampleRateChanged(ByVal e As EventArgs)
        RaiseEvent SampleRateChanged(Me, e)
    End Sub

    Public Sub New(ByVal samplesPerSecond As Integer)
        If samplesPerSecond < 1 Then
            Throw New ArgumentOutOfRangeException("samplesPerSecond")
        End If
        Me.m_samplesPerSecond = samplesPerSecond
    End Sub

    Public Property SamplesPerSecond() As Integer
        Get
            Return m_samplesPerSecond
        End Get
        Set(ByVal value As Integer)
            If value < 1 Then Throw New ArgumentOutOfRangeException("value")
            If value = Me.m_samplesPerSecond Then Return
            Me.m_samplesPerSecond = value
            OnSampleRateChanged(EventArgs.Empty)
        End Set
    End Property

End Class


