

Imports System.Collections.Generic
Imports System.IO

Public Partial Class Synthesizer

    ' ------------------------------------------------------ loads bank data from file using the specified file name
	Public Sub LoadBank(fileName As String)
		SyncLock lockObject
			Dim wasPlaying As Boolean = playing
            Try
                ' -------------------------------------- Momentarily stop playback
                If playing Then PlayStop()
                bank.Load(fileName)
                ResetProgram()
                RaiseEvent BankLoaded(Me, EventArgs.Empty)
            Finally
                If wasPlaying Then PlayStart()
            End Try
        End SyncLock
    End Sub


    ' ------------------------------------------------------ saves bank data to file using the specified file name
    Public Sub SaveBank(ByVal fileName As String)
        SyncLock lockObject
            Dim wasPlaying As Boolean = playing
            Try
                ' -------------------------------------- Momentarily stop playback
                If playing Then PlayStop()
                bank.Save(fileName)
            Finally
                If wasPlaying Then PlayStart()
            End Try
        End SyncLock
    End Sub


    ' ------------------------------------------------------ loads program data from file using file name
    Public Sub LoadProgram(ByVal fileName As String)
        SyncLock lockObject
            Dim wasPlaying As Boolean = playing
            Try
                ' -------------------------------------- Momentarily stop playback
                If playing Then PlayStop()
                bank(programIndex).Load(fileName)
                ResetProgram()
                RaiseEvent ProgramLoaded(Me, EventArgs.Empty)
            Finally
                If wasPlaying Then PlayStart()
            End Try
        End SyncLock
    End Sub


    ' ------------------------------------------------------ saves program data to file using the specified file name
    Public Sub SaveProgram(ByVal fileName As String)
        SyncLock lockObject
            Dim wasPlaying As Boolean = playing
            Try
                ' -------------------------------------- Momentarily stop playback
                If playing Then PlayStop()
                bank(programIndex).Save(fileName)
            Finally
                If wasPlaying Then PlayStart()
            End Try
        End SyncLock
    End Sub

End Class
